cls
@echo off
	@ECHO *********************************************************
	@ECHO  Batch file for JTAGICE calibration of ATmega169 through
	@ECHO  JTAG interface. 
	@ECHO  - The internal RC is calibrated to 1MHz (8MHz divided by 8).
	@ECHO  - Programming FLASH and Fuses is performed initially.
	@ECHO  - Com 1 port used for the JTAGICE
	@ECHO  
	@ECHO  Revision: $Revision: 3.1 $                            
	@ECHO  Last Change: $Date: Monday, November 17, 2003 3:56:30 PM $
	@ECHO *********************************************************
	
	@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO   ** S T A R T   P R O G R A M M I N G **
	@ECHO.		

@ECHO ---------------------------------------------------------
"C:\Program Files\Atmel\AVR Tools\JTAGICE\JTAGICE.exe" -ccom1 -dATMEGA169 -R -B115200 -Eff, -f1942 -e -pf -if"..\rc_calibration.hex"

@IF ERRORLEVEL ==1 GOTO prog_Calib_code_error
		
	@ECHO.
	@ECHO  ** Start Calibration

@ECHO ---------------------------------------------------------
"C:\Program Files\Atmel\AVR Tools\JTAGICE\JTAGICE.exe" -B115200 -ccom1 -Y

@IF ERRORLEVEL ==1 GOTO Calibration_error

@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO Verify that OSCCAL value is differs from 0xFF.
	@ECHO Note, this test is intended to fail. If it does
	@ECHO not fail, OSCCAL equals 0xFF which is considered 
	@ECHO an error

"C:\Program Files\Atmel\AVR Tools\JTAGICE\JTAGICE.exe" -ccom1 -B115200 -ae0,0 -ve -ie0xFF_byte.hex

@IF ERRORLEVEL ==1 GOTO continue

@GOTO EEPROM_OSCCAL_value_error

:continue
		
@ECHO           ^^ Ignore Error above ^^
@ECHO.
@ECHO ---------------------------------------------------------
	@ECHO Read out OSCCAL from EEPROM and erase the device.
	@ECHO Program in customers code to FLASH, in this case test.hex.
	@ECHO Verify programming of customers code
	@ECHO Program in OSCCAL at byte addr 03FFF
	@ECHO Verify programming of OSCCAL byte to Flash		
"C:\Program Files\Atmel\AVR Tools\JTAGICE\JTAGICE.exe" -ccom1 -B115200 -R -e -pf -vf -iftest.hex -Z0 -Sf3FFF

@IF ERRORLEVEL ==1 GOTO prog_customer_code_error

	@ECHO.
	@ECHO *********************************************************
	@ECHO 		P R O G R A M M I N G   O K
	@ECHO *********************************************************

@GOTO END

:prog_Calib_code_error
	@ECHO.
@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO 		E R R O R		
	@ECHO Programming calibration program to AVR failed
	@ECHO Programming aborted
	@PAUSE
	@GOTO END
@ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


:Calibration_error
	@ECHO.
@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO 		E R R O R
	@ECHO Calibration failed
	@ECHO Programming aborted
	@PAUSE
	@GOTO END
@ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

:EEPROM_OSCCAL_value_error
	@ECHO.
@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO 		E R R O R
	@ECHO EEPROM OSCCAL location contain an invalid value: 0xFF
	@ECHO Programming aborted
	@PAUSE
	@GOTO END
@ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

:prog_customer_code_error
	@ECHO.
@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO 		E R R O R
	@ECHO Programming main application program or OSCCAL to AVR failed
	@ECHO Programming aborted
	@PAUSE
	@GOTO END
@ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

:END				
